#include "ListaEncadeada.h"
#include "Hashing.h"

void gerarPesosHZ(TipoPesos p)
{
    struct timeval semente;
    gettimeofday(&semente, NULL);
    srand((int)(semente.tv_sec + 1000000*semente.tv_usec));
    for(int i = 0; i < N; ++i)
        for(int j = 0; j < TAMALFABETO; ++j)
            p[i][j] = 1 + (int)(10000.0*rand()/(RAND_MAX+1.0));
}

TipoIndice hZobrist(TipoChave chave, TipoPesos p)
{
    unsigned int soma = 0;
    int comp = strlen(chave);
    for(int i = 0; i < comp; ++i)
        soma += p[i][(unsigned int)chave[i]];
    return (soma%M);
}

/*void gerarPesos(TipoPesos p)
{
    struct timeval semente;
    gettimeofday(&semente, NULL);
    srand((int)(semente.tv_sec + 1000000*semente.tv_usec));
    for(int i = 0; i < N; ++i)
    {
        p[i] = 1+(int) (10000.0*rand()/(RAND_MAX+1.0));
    }
}*/

/*TipoIndice h(TipoChave chave, TipoPesos p)
{
    unsigned int soma = 0;
    int comp = strlen(chave);
    for(int i = 0; i < comp; ++i)
        soma += (unsigned int)chave[i]*p[i];
    return (soma%M);
}*/

TipoApontador pesquisa(TipoChave chave, TipoPesos pesos, TipoDicionario dicionario)
{
    TipoIndice indice;
    TipoApontador apontador;
    indice = hZobrist(chave, pesos);
    if(vazia(dicionario[indice]))
        return NULL;
    else
    {
        apontador = dicionario[indice].primeiro;
        while(apontador->prox->prox != NULL &&
            strncmp(chave, apontador->prox->item.chave, sizeof(TipoChave)))
        {
            apontador = apontador->prox;
        }
        if(!strncmp(chave, apontador->prox->item.chave, sizeof(TipoChave)))
            return apontador;
        else
            return NULL;
    }
}

void inicializa(TipoDicionario dicionario)
{
    for (int i = 0; i < M; ++i) {
        criaListaVazia(&dicionario[i]);
    }
}

void insereHash(TipoItem item, TipoPesos pesos, TipoDicionario dicionario)
{
    if (pesquisa(item.chave, pesos, dicionario) == NULL)
        insereLista(item, &dicionario[hZobrist(item.chave, pesos)]);
    else
        printf("Registro ja esta presente\n");
}

void retiraHash(TipoItem item, TipoPesos pesos, TipoDicionario dicionario)
{
    TipoApontador apontador;

    apontador = pesquisa(item.chave, pesos, dicionario);
    if (apontador == NULL)
        printf("Registro nao esta presente\n");
    else
    {
        retiraLista(apontador, &dicionario[hZobrist(item.chave, pesos)], &item);
        printf("Retirado com sucesso\n");
    }
}

void lerPalavra(char *palavra, int tam)
{
    char c;
    int i, j;
    fflush(stdin); j=0;
    while ( ( ( c=getchar() )!='\n' ) && j<tam-1 )
    {
        palavra[j++]= c;
    }
    palavra[j]='\0';
    while(c != '\n')
        c=getchar();
    /* Desconsiderar espacos ao final
    da cadeia como ocorre em Pascal.*/
    for(i=j-1; (i>=0 && palavra[i]==' '); i--)
        palavra[i]='\0';
}

void imprime(TipoDicionario dicionario)
{
    for (int i = 0; i < M; i++)
    {
        printf("%d: ", i);
        if (!vazia(dicionario[i]))
            imprimeLista(dicionario[i]);
        putchar('\n');
    }
}

int main()
{
    TipoDicionario dicionario;
    TipoPesos pesos;
    TipoItem item;
    TipoApontador i;

    inicializa(dicionario);
    gerarPesosHZ(pesos);
    lerPalavra(item.chave,N);
    while (strcmp(item.chave, "aaaaaa") != 0)
    {
        insereHash(item, pesos, dicionario);
        lerPalavra(item.chave,N);
    }
    printf("Tabela apos insercao:\n");
    imprime(dicionario);
    printf("Pesquisar :  ");
    lerPalavra(item.chave,N);
    while (strcmp(item.chave, "aaaaaa") != 0)
    {
        i = pesquisa(item.chave, pesos, dicionario);
        if (i == NULL)
            printf("pesquisa sem sucesso \n");
        else
            printf("sucesso \n");
        printf("Pesquisar :  ");
        lerPalavra(item.chave,N);
    }
    printf("Retirar seguintes chaves:\n");
    lerPalavra(item.chave,N);
    while (strcmp(item.chave, "aaaaaa") != 0)
    {
        retiraHash(item, pesos, dicionario);
        lerPalavra(item.chave,N);
    }
    printf("Tabela apos retiradas:\n");
    imprime(dicionario);
    printf("Inserir de novo os elementos seguintes:\n");
    lerPalavra(item.chave,N);
    while (strcmp(item.chave, "aaaaaa") != 0)
    {
        insereHash(item, pesos, dicionario);
        lerPalavra(item.chave,N);
    }
    printf("Tabela apos novas insercoes:\n");
    imprime(dicionario);
    return 0;
}
